# Summary

* [简介](README.md)
   * [序](Introduction.md)
   * [译后感](translator.md)
   * [原作者前言](author.md)
* [*args 和 **kwargs](args_kwargs/README.md)
   * [*args 的用法](args_kwargs/Usage_args.md)
   * [**kwargs 的用法](args_kwargs/Usage_kwargs.md)
   * [使用 *args 和 **kwargs 来调用函数](args_kwargs/Using_args_and_kwargs_to_call_function.md)
   * [啥时候使用它们](args_kwargs/When_to_use.md)
* [调试 Debugging](Debugging/README.md)
* [生成器 Generators](Generators/README.md)
   * [可迭代对象(Iterable)](Generators/Iterable.md)
   * [迭代器(Iterator)](Generators/Iterator.md)
   * [迭代(Iteration)](Generators/Iteration.md)
   * [生成器(Generators)](Generators/Generators.md)
* [Map，Filter 和 Reduce](Map & Filter/README.md)
   * [Map](Map & Filter/Map.md)
   * [Filter](Map & Filter/Filter.md)
   * [Reduce](Map & Filter/Reduce.md)
* [set 数据结构](set_data_structure/set_data_structure.md)
* [三元运算符](ternary_operators/ternary_operators.md)
* [装饰器](decorators/README.md)
   * [一切皆对象](decorators/everything_is_object.md)
   * [在函数中定义函数](decorators/def_func_in_func.md)
   * [从函数中返回函数](decorators/return_func_in_func.md)
   * [将函数作为参数传给另一个函数](decorators/func_as_argument.md)
   * [你的第一个装饰器](decorators/your_first_decorator.md)
       * [使用场景](decorators/use_cases.md)
       * [授权](decorators/auth.md)
       * [日志](decorators/logging.md)
   * [带参数的装饰器](decorators/deco_with_args.md)
       * [在函数中嵌入装饰器](decorators/nest_deco_in_func.md)
       * [装饰器类](decorators/deco_class.md)
* [Global和Return](global_return/README.md)
   * [多个return值](global_return/multiple_return_values.md)
* [对象变动 Mutation](Mutation/README.md)
* [__slots__魔法](slots_magic/README.md)
* [虚拟环境](virtual_environment/virtual_environment.md)
* [容器 Collections](collections/collections.md)
* [枚举 Enumerate](Enumerate/Enumerate.md)
* [对象自省](introspection/README.md)
   * [dir](introspection/dir.md)
   * [type和id](introspection/type_and_id.md)
   * [inspect模块](introspection/inspect.md)
* [推导式 Comprehension](Comprehensions/README.md)
   * [列表推导式](Comprehensions/list-comprehensions.md)
   * [字典推导式](Comprehensions/dict-comprehensions.md)
   * [集合推导式](Comprehensions/set-comprehensions.md)
* [异常](exception/README.md)
   * [处理多个异常](exception/multiple_exception.md)
       * [finally从句](exception/finally_clause.md)
       * [try/else从句](exception/try_else_clause.md)
* [lambda表达式](Lambdas/README.md)
* [一行式](Onelines/README.md)
* [For - Else](for_else/README.md)
   * [else语句](for_else/else_clause.md)
* [使用C扩展](c_extensions/README.md)
   * [CTypes](c_extensions/ctypes.md)
   * [SWIG](c_extensions/swig.md)
   * [Python/C API](c_extensions/python_c_api.md)
* [open函数](open_func/open_func.md)
* [目标Python2+3](TargetingPython2+3/README.md)
* [协程](Coroutines/README.md)
* [函数缓存](func_caching/README.md)
   * [Python 3.2+](func_caching/python_32.md)
   * [Python 2+](func_caching/python_2.md)
* [上下文管理器](context_managers/README.md)
   * [基于类的实现](context_managers/implement_as_class.md)
   * [处理异常](context_managers/handle_exception.md)
   * [基于生成器的实现](context_managers/implement_as_generator.md)
* [推荐阅读](seealso.md)
* [捐赠名单](donors.md)

